public class A3ShuffleExchange {
  public static void main(String[] args) {
    if (args.length < 2) {
      System.out.println("Aufruf: java A3ShuffleExchange n z");
      return;
    }
    int k, z;
    try {
      k = Integer.parseInt(args[0]);
      z = Integer.parseInt(args[1]);
    } catch (NumberFormatException e) {
      e.printStackTrace();
      return;
    }

    //starte auf Tastendruck
    System.out.println("Start mit <ENTER>");
    try {
      System.in.read();
    } catch (java.io.IOException e) {e.printStackTrace();}


    int n = 1 << k;

    A3Thread[] ts = new A3Thread[n];
    for (int i = 0; i < n; i++) ts[i] = new A3Thread(i, n, z);
    for (int i = 0; i < n - 1; i++) {
      ts[i].setExchangeTarget(ts[i^1]);
      ts[i].setShuffleTarget(ts[2*i % (n-1)]);
    }
    ts[n-1].setExchangeTarget(ts[(n-1)^1]);
    ts[n-1].setShuffleTarget(ts[n-1]);

    for (Thread t : ts) t.start();


  }
}